
;; ==================
;; ----- Traces -----
;; ==================

(define-condition invalidates-assertion (error)
  ((text :initarg :text :reader text)))
(define-condition violation-witness-error (error)
  ((text :initarg :text :reader text)))
(define-condition violation-witness-found (error)
  ((text :initarg :text :reader text)))

(defparameter *total-trace-time* 0)

;; pgraph node -> [node list]
(defun get-successors (pgraph node)
  (list.filter #'(lambda (edge)
		   (equal (edge.from edge) node))
	       (pgraph.edges pgraph)))

#|
(defun compute (n acc)
  (if (equal n 0)
      acc
    (compute (- n 1)
	     (let* ((len (+ (length acc) 1)))
	       (if (equal (random len) 0)
		   (cons n acc)
		 acc)))))
This is basically the function that is used to keep the "middle" elements the traces (per state), after the beginning and end are taken care of
On average it gives back a list of size 4/3 sqrt(n)
1000 ~ 40
10000 ~ 140
100000 ~ 445

aka multiplying by 4 increases by a factor of 2

|#

(defparameter *violation-state* '_)
(defparameter *violation-witness-graph* '_)

(defun generate-trace-for-violation (start-state start-node pgraph pgraph-ACL2-data assertions main-node prepped-pgraph correct-start-node name-map)
  (let* ((trace ())
	 (start nil)
	 (quit nil))
  (labels ((run (state node)
		(if (equal (node.name node) (node.name main-node)) (setf start t) '_)

		(let* ((successors (get-successors pgraph node))
		       (vars (node.live-vars node))
		       (succ-opt (list.find #'(lambda (edge)
						(equal (funcall (definec.name (map.find-exn (pgraph-ACL2-data.conditions pgraph-ACL2-data) (edge.name edge)))
								state)
						       t))
					    successors)))
		  (if (option.exists succ-opt)
		      (progn (if (option.exists (map.find assertions (node.name node)))
				 (let* ((assertion (map.find-exn assertions (node.name node)))
					(assignment (list.foldr2 #'(lambda (var-pair value acc) (cons (list (car var-pair) value) acc)) () (node.live-vars node) state)))
				   (if (ce-is-ce-to-verif-cond assertion assignment)
				       (progn (setf trace (cons (list node '_ (option.get succ-opt) '_) trace))
					      (setf quit t))
				     '_))
			       '_)
			     (if quit
				 '_
			       (let* ((succ-edge (option.get succ-opt))
				      (succ (edge.to succ-edge))
				      (succ-name (node.name succ))
				      (vars* (node.live-vars succ))
				      (state* (funcall (definec.name (map.find-exn (pgraph-ACL2-data.statements pgraph-ACL2-data) (edge.name succ-edge))) state))
				      (assignment (list.foldr2 #'(lambda (var-pair value acc)
								   (if (and (not (equal (car var-pair) 'nondet))
									    (not (equal (car var-pair) 'counter)))
								       (cons (pair.make (car var-pair) value)
									     acc)
								     acc))
							       () vars* state*)))
				 (if start (setf trace (cons (list node state* succ-edge succ) trace)) '_)
				 (run state* succ))))
		    (error 'violation-witness-error)))))
	  (run start-state start-node)
	  (setf *violation-witness-graph* (create-violation-witness-graph prepped-pgraph trace correct-start-node name-map assertions))
	  (error 'violation-witness-found))))


(defparameter *begin-size* 3)
(defparameter *end-size* 3)

;; N state node pgraph pgraph-ACL2-data [node-name [assignment list] mmap] -> '_
;; assumes mmap and sizes is defined on every node
(defun generate-trace-modified (fuel state node pgraph pgraph-ACL2-data mmap check-assertions assertions start-state)
  (let* ((sizes (mmap.empty))
	 (run-mmap (mmap.empty)))
    (mmap.iter #'(lambda (nn _) (mmap.add-exn sizes nn 0)) mmap)
    (mmap.iter #'(lambda (nn _) (mmap.add-exn run-mmap nn (list () () ()))) mmap)
    (labels ((run (fuel state node)
		  (if (< fuel 0)
		      '_
		    (let* ((successors (get-successors pgraph node))
			   (vars (node.live-vars node))
			   (succ-opt (list.find #'(lambda (edge)
						    (equal (funcall (definec.name (map.find-exn (pgraph-ACL2-data.conditions pgraph-ACL2-data) (edge.name edge)))
								    state)
							   t))
						successors)))
		      (if (option.exists succ-opt)
			  (let* ((succ-edge (option.get succ-opt))
				 (succ (edge.to succ-edge))
				 (succ-name (node.name succ))
				 (vars* (node.live-vars succ))
				 (state* (funcall (definec.name (map.find-exn (pgraph-ACL2-data.statements pgraph-ACL2-data) (edge.name succ-edge))) state))
				 (triple (mmap.find-exn run-mmap succ-name))
				 (begin (car triple))
				 (middle (cadr triple))
				 (end (caddr triple))
				 (size (mmap.find-exn sizes succ-name))
				 (assignment (list.foldr2 #'(lambda (var-pair value acc)
							      (if (and (not (equal (car var-pair) 'nondet))
								       (not (equal (car var-pair) 'counter)))
								  (cons (pair.make (car var-pair) value)
									acc)
								acc))
							  () vars* state*))
				 (_ (if (and check-assertions (option.exists (map.find assertions succ-name)))
					(let* ((assertion (map.find-exn assertions succ-name)))
					  (if (ce-is-ce-to-verif-cond assertion (list.map #'(lambda (pair) (list (pair.first pair) (pair.second pair))) assignment))
					      (progn (setf *violation-start-state* start-state)
						     (error 'invalidates-assertion))
					    '_))
				      '_))
				 (add-new (or (< size *end-size*) (< size (+ *begin-size* *end-size*)) (equal (random (+ (- size (+ *begin-size* *end-size*)) 1)) 0)))
				 (triple* (cond ((< size *end-size*)
						 (let* ((begin* begin)
							(middle* middle)
							(end* (append end (list assignment))))
						   (list begin* middle* end*)))
						((< size (+ *begin-size* *end-size*))
						 (let* ((begin* (cons (car end) begin))
							(middle* middle)
							(end* (append (cdr end) (list assignment))))
						   (list begin* middle* end*)))
						(t
						 (let* ((begin* begin)
							(middle* (if add-new
								     (cons (car end) middle)
								   middle))
							(end* (append (cdr end) (list assignment))))
						   (list begin* middle* end*))))))
			    (if add-new (mmap.add-overwrite sizes succ-name (+ size 1)) '_)
			    (mmap.add-overwrite run-mmap succ-name triple*)
			    (run (- fuel 1) state* succ))
			'_)))))
	    (run fuel state node)
	    (mmap.iter #'(lambda (nn triple)
			   (let* ((begin (car triple)) (middle (cadr triple)) (end (caddr triple)))
			     (mmap.add-overwrite mmap nn (append begin middle end (mmap.find-default mmap nn ())))))
		       run-mmap))))


;; N state node pgraph pgraph-ACL2-data [node-name [assignment list] mmap] [node-name N mmap] -> '_
;; assumes mmap and sizes is defined on every node
(defun generate-trace (fuel state node pgraph pgraph-ACL2-data mmap sizes)
  (if (< fuel 0)
      '_
    (let* ((successors (get-successors pgraph node))
	   (vars (node.live-vars node))
	   (succ-opt (list.find #'(lambda (edge)
				    (equal (funcall (definec.name (map.find-exn (pgraph-ACL2-data.conditions pgraph-ACL2-data) (edge.name edge)))
						    state)
					   t))
			     successors)))
      (if (option.exists succ-opt)
	  (let* ((succ-edge (option.get succ-opt))
		 (succ (edge.to succ-edge))
		 (vars* (node.live-vars succ))
		 (state* (funcall (definec.name (map.find-exn (pgraph-ACL2-data.statements pgraph-ACL2-data) (edge.name succ-edge))) state))
		 (size (mmap.find-exn sizes (node.name succ))))
	    (if (or (<= size 10) (< (random (* (- size 10) (- size 10))) (- size 10)))
		(let* ((assignment (list.foldr2 #'(lambda (var-pair value acc)
						    (if (and (not (equal (car var-pair) 'nondet))
							     (not (equal (car var-pair) 'counter)))
							(cons (pair.make (car var-pair) value)
							      acc)
						      acc))
						() vars* state*)))
		  (mmap.add-overwrite mmap (node.name succ) 
				      (cons assignment (mmap.find-exn mmap (node.name succ))))
		  (mmap.add-overwrite sizes (node.name succ) (+ size 1)))
	      '_)
	    (generate-trace (- fuel 1) state* succ pgraph pgraph-ACL2-data mmap sizes))
	'_))))

;; 'a N -> ['a list]
(defun list-duplicate (e n)
  (if (<= n 0)
      ()
    (cons e (list-duplicate e (- n 1)))))
	       
(defun create-random-uint ()
  (random *c-uint-max*))

(defun create-uint-list (len)
  (if (<= len 0)
      ()
    (cons (create-random-uint) (create-uint-list (- len 1)))))

(defun create-random-int ()
  (- *c-uint-max* (random (* 2 *c-uint-max*))))

(defun create-int-list (len)
  (if (<= len 0)
      ()
    (cons (create-random-int) (create-uint-list (- len 1)))))

(defun create-random-bool ()
  (< 7 (random 8)))

(defun create-bool-list (len)
  (if (<= len 0)
      ()
    (cons (create-random-bool) (create-bool-list (- len 1)))))
    
(defun create-char-list (len)
  ())

(defun create-nondet (len)
  (list (create-uint-list len) (create-int-list len) (create-bool-list len) (create-char-list len)))

(defun create-random-nondets (len num)
  (if (<= num 0)
      ()
    (cons (create-nondet len) (create-random-nondets len (- num 1)))))

(defun create-random-uint-from-constants (consts)
  (if (endp consts) (create-random-uint)
  (let* ((r (list.nth consts (random (length consts))))
	 (r* (let* ((a (random 3))) (cond ((equal a 0) r)
					  ((equal a 1) (c-uint-+ r 1))
					  ((equal a 2) (c-uint-- r 1))))))
    r*)))

(defun create-random-int-from-constants (consts)
  (if (endp consts) (create-random-int)
  (let* ((r (list.nth consts (random (length consts))))
	 (r* (let* ((a (random 3))) (cond ((equal a 0) r)
					  ((equal a 1) (c-int-+ r 1))
					  ((equal a 2) (c-int-- r 1))))))
    r*)))
(defun create-random-bool-from-constants (consts)
  (if (endp consts) (create-random-bool)
    (let* ((r (list.nth consts (random (length consts)))))
      r)))
(defun create-random-char-from-constants (consts)
  (if (endp consts) #\R
    (let* ((r (list.nth consts (random (length consts)))))
      r)))


(defun create-uint-list-constants (len consts)
  (if (<= len 0)
      ()
    (cons (create-random-uint-from-constants consts)
	  (create-uint-list-constants (- len 1) consts))))

(defun create-int-list-constants (len consts)
  (if (<= len 0)
      ()
    (cons (create-random-int-from-constants consts)
	  (create-int-list-constants (- len 1) consts))))

(defun create-bool-list-constants (len consts)
  (if (<= len 0)
      ()
    (cons (create-random-bool-from-constants consts)
	  (create-bool-list-constants (- len 1) consts))))

    
(defun create-char-list-constants (len consts)
  (if (<= len 0)
      ()
    (cons (create-random-char-from-constants consts)
	  (create-char-list-constants (- len 1) consts))))

(defun create-nondet-constants (len constants)
  (let* ((uint-consts (list.foldr #'(lambda (pair acc) (let* ((const (car pair)) (type (cadr pair))) (if (equal type 'c-uintp) (cons const acc) acc))) () constants))
	 (int-consts (list.foldr #'(lambda (pair acc) (let* ((const (car pair)) (type (cadr pair))) (if (equal type 'c-intp) (cons const acc) acc))) () constants))
	 (bool-consts (list.foldr #'(lambda (pair acc) (let* ((const (car pair)) (type (cadr pair))) (if (equal type 'c-boolp) (cons const acc) acc))) () constants))
	 (char-consts (list.foldr #'(lambda (pair acc) (let* ((const (car pair)) (type (cadr pair))) (if (equal type 'c-charp) (cons const acc) acc))) () constants)))
    (list (if (endp uint-consts) () (create-uint-list-constants len uint-consts))
	  (if (endp int-consts) () (create-int-list-constants len int-consts))
	  (if (endp bool-consts) () (create-bool-list-constants len bool-consts))
	  (if (endp char-consts) () (create-char-list-constants len char-consts)))))

(defun create-random-nondets-constants (len num constants)
  (if (<= num 0)
      ()
    (cons (create-nondet-constants len constants) (create-random-nondets-constants len (- num 1) constants))))

(defun extract-state-from-assignment (node assignment)
  (list.map #'(lambda (var) (cadr (option.get (list.find #'(lambda (pair) (equal (car pair) (car var))) assignment)))) (node.live-vars node)))

(defun create-start-state-from-nondets (start-node nondets constraints)
  ;;(print `(implies ,(cons 'and (append (node.thm-hyps start-node) constraints)) nil))
  (list.map #'(lambda (nondet)
		(let* ((other (if (> (length (node.live-vars start-node)) 2) ;; don't bother if don't need
				  (let* ((assignments (acl2s-generate-counter-examples `(implies ,(cons 'and (append (node.thm-hyps start-node) constraints)) nil) 1)))
				    (if (endp assignments) (error 'unimplemented)
				      (car assignments)))
				())))
		      (list.map #'(lambda (var)
				    (cond ((equal (car var) 'counter)
					   0)
					  ((equal (car var) 'nondet)
					   nondet)
					  (t (cadr (option.get (list.find #'(lambda (pair) (equal (car pair) (car var))) other))))))
				(node.live-vars start-node))))
	    nondets))

;; node N -> ???
(defun create-start-states (start-node num constants original-constraints generalize-constraints use-generalized)
  ;;(print (list 'hello start-node datap num))
  (let* ((nondets `(((3456 1345 13 524562) (3245 42 63 15) (t nil t t nil t nil nil) ())
		    ((0 3456 1345 13 524562) (10 3245 42 63 15) (t nil t t nil t nil nil) ())
		    ((10 3456 1345 13 524562) (0 3245 42 63 15) (t nil t t nil t nil nil) ())
		    ((100 0 0 0 0) (100 3245 42 63 15) ,(list-duplicate nil 1000) ())
		    ((,(- (expt 2 32) 2) ,(- (expt 2 32) 7) 3245 42 63 15) (12 1345 13 524562) (t nil t t nil t nil nil) ())
		    ((,(- (expt 2 32) 7) 3245 42 63 15) (32 1345 13 524562) (t t t t nil t nil nil) ())
		    ((,(- (expt 2 32) 1) 3245 42 63 15) (100 1345 13 524562) (t nil t t nil t nil nil) ())
		    ((,(- (expt 2 32) 1) 3245 42 63 15) (100 1345 13 524562) ,(list-duplicate t 1000) ())
		    ((0 0 3456 1345 13 524562) (0 0 3245 42 63 15) (t nil t t nil t nil nil) ()))
		  )
	 (nondets* (create-random-nondets 100 (/ num 3)))
	 (nondets** (create-random-nondets-constants 100 (/ num 6) constants))
	 (constraints (if use-generalized generalize-constraints original-constraints))
	 (start-states (create-start-state-from-nondets start-node (append nondets nondets* nondets**) constraints))
	 (start-states*
	  (list.map #'(lambda (assignment) (extract-state-from-assignment start-node assignment))
		    (acl2s-generate-counter-examples `(implies ,(cons 'and (append (node.thm-hyps start-node) constraints)) nil) (/ num 2))))
	 )
	;;(print start-states)
	;;(print start-states*)
	(append start-states start-states*)))
  

;; pgraph N N node -> [node-name [assignment list] mmap]
(defun generate-traces (pgraph pgraph-ACL2-data fuel num start-node constants original-constraints generalize-constraints check-assertions assertions &key (use-generalized t))
  (let* ((start (get-internal-real-time))
	 (res (let* ((nodes (pgraph.nodes pgraph))
		     (mmap (mmap.empty))
		     (_ (list.iter #'(lambda (node) (mmap.add-exn mmap (node.name node) ())) nodes))
		     (start-states (create-start-states start-node num constants original-constraints generalize-constraints use-generalized))
		     (_ (mmap.add-overwrite mmap (node.name start-node) (list.map #'(lambda (x) (list.foldr2 #'(lambda (var value acc)
														 (if (and (not (equal var 'nondet)) (not (equal var 'counter)))
														     (map.add-exn acc (var.ACL2-var var) value)
														   acc))
													     map.empty (node.live-vars start-node) x))
										  start-states)))
		     (_ (list.iter #'(lambda (start-state)
				       #|(let* ((sizes (mmap.empty)))
				       (list.iter #'(lambda (node) (mmap.add-exn sizes (node.name node) 0)) nodes)
				       (mmap.add-overwrite sizes (node.name start-node) (length start-states))
				       (generate-trace fuel start-state start-node pgraph pgraph-ACL2-data mmap sizes))|#
				       (generate-trace-modified fuel start-state start-node pgraph pgraph-ACL2-data mmap check-assertions assertions start-state)
				       )
				   start-states)))
		mmap))
	 (end (get-internal-real-time)))
    (setf *total-trace-time* (+ *total-trace-time* (- end start)))
    res))












;; N state node pgraph pgraph-ACL2-data [node-name [assignment list] mmap] [node-name N mmap] -> '_
;; assumes mmap and sizes is defined on every node
(defun generate-trace-in-component-modified (fuel state node pgraph pgraph-ACL2-data mmap component)
  (let* ((sizes (mmap.empty))
	 (run-mmap (mmap.empty)))
    (mmap.iter #'(lambda (nn _) (mmap.add-exn sizes nn 0)) mmap)
    (mmap.iter #'(lambda (nn _) (mmap.add-exn run-mmap nn (list () () ()))) mmap)
    (labels ((run (fuel state node)
		  (if (< fuel 0)
		      '_
		    (let* ((successors (get-successors pgraph node))
			   (vars (node.live-vars node))
			   (succ-opt (list.find #'(lambda (edge)
						    (equal (funcall (definec.name (map.find-exn (pgraph-ACL2-data.conditions pgraph-ACL2-data) (edge.name edge)))
								    state)
							   t))
						successors)))
		      (if (and (option.exists succ-opt) (list.in (edge.to (option.get succ-opt)) component))
			  (let* ((succ-edge (option.get succ-opt))
				 (succ (edge.to succ-edge))
				 (succ-name (node.name succ))
				 (vars* (node.live-vars succ))
				 (state* (funcall (definec.name (map.find-exn (pgraph-ACL2-data.statements pgraph-ACL2-data) (edge.name succ-edge))) state))
				 (triple (mmap.find-exn run-mmap succ-name))
				 (begin (car triple))
				 (middle (cadr triple))
				 (end (caddr triple))
				 (size (mmap.find-exn sizes succ-name))
				 (assignment (list.foldr2 #'(lambda (var-pair value acc)
							      (if (and (not (equal (car var-pair) 'nondet))
								       (not (equal (car var-pair) 'counter)))
								  (cons (pair.make (car var-pair) value)
									acc)
								acc))
							  () vars* state*))
				 (add-new (or (< size *end-size*) (< size (+ *begin-size* *end-size*)) (equal (random (+ (- size (+ *begin-size* *end-size*)) 1)) 0)))
				 (triple* (cond ((< size *end-size*)
						 (let* ((begin* begin)
							(middle* middle)
							(end* (append end (list assignment))))
						   (list begin* middle* end*)))
						((< size (+ *begin-size* *end-size*))
						 (let* ((begin* (cons (car end) begin))
							(middle* middle)
							(end* (append (cdr end) (list assignment))))
						   (list begin* middle* end*)))
						(t
						 (let* ((begin* begin)
							(middle* (if add-new
								     (cons (car end) middle)
								   middle))
							(end* (append (cdr end) (list assignment))))
						   (list begin* middle* end*))))))
			    (if add-new (mmap.add-overwrite sizes succ-name (+ size 1)) '_)
			    (mmap.add-overwrite run-mmap succ-name triple*)
			    (run (- fuel 1) state* succ))
			'_)))))
	    (run fuel state node)
	    (mmap.iter #'(lambda (nn triple)
			   (let* ((begin (car triple)) (middle (cadr triple)) (end (caddr triple)))
			     (mmap.add-overwrite mmap nn (append begin middle end (mmap.find-default mmap nn ())))))
		       run-mmap))))



;; N state node pgraph pgraph-ACL2-data [node-name [assignment list] mmap] [node-name N mmap] -> '_
;; assumes mmap and sizes is defined on every node
(defun generate-trace-in-component (fuel state node pgraph pgraph-ACL2-data mmap sizes component)
  (if (< fuel 0)
      '_
    (let* ((successors (get-successors pgraph node))
	   (vars (node.live-vars node))
	   (succ-opt (list.find #'(lambda (edge)
				    (equal (funcall (definec.name (map.find-exn (pgraph-ACL2-data.conditions pgraph-ACL2-data) (edge.name edge)))
						    state)
					   t))
			     successors)))
      (if (and (option.exists succ-opt) (list.in (edge.to (option.get succ-opt)) component))
	  (let* ((succ-edge (option.get succ-opt))
		 (succ (edge.to succ-edge))
		 (vars* (node.live-vars succ))
		 (state* (funcall (definec.name (map.find-exn (pgraph-ACL2-data.statements pgraph-ACL2-data) (edge.name succ-edge))) state))
		 (size (mmap.find-exn sizes (node.name succ))))
	    (if (or (<= size 10) (< (random (* (- size 10) (- size 10))) (- size 10)))
		(let* ((assignment (list.foldr2 #'(lambda (var-pair value acc)
						    (if (and (not (equal (car var-pair) 'nondet))
							     (not (equal (car var-pair) 'counter)))
							(cons (pair.make (car var-pair) value)
							      acc)
						      acc))
						() vars* state*)))
		  (mmap.add-overwrite mmap (node.name succ) 
				      (cons assignment (mmap.find-exn mmap (node.name succ))))
		  (mmap.add-overwrite sizes (node.name succ) (+ size 1)))
	      '_)
	    (generate-trace-in-component (- fuel 1) state* succ pgraph pgraph-ACL2-data mmap sizes component))
	'_))))

(defun create-state-from-nondets-at (node nondets assignments)
  (if (endp assignments)
      ()
    (if (endp nondets)
	(error 'unimplemented)
      (let* ((assignment (car assignments))
	     (nondet (car nondets))
	     (res (create-state-from-nondets-at node (cdr nondets) (cdr assignments)))
	     (state (list.map #'(lambda (var)
				  (cond ((equal (car var) 'counter)
					 0)
					((equal (car var) 'nondet)
					 nondet)
					(t (map.find-exn assignment (car var)))))
			      (node.live-vars node))))
	(cons state res)))))

;; node N -> ???
(defun create-states-at (node constants assignments)
  (let* ((nondets `(((3456 1345 13 524562) (3245 42 63 15) (t nil t t nil t nil nil) ())
		   ((0 3456 1345 13 524562) (10 3245 42 63 15) (t nil t t nil t nil nil) ())
		   ((10 3456 1345 13 524562) (0 3245 42 63 15) (t nil t t nil t nil nil) ())
		   ((100 0 0 0 0) (100 3245 42 63 15) ,(list-duplicate nil 1000) ())
		   ((,(- (expt 2 32) 2) ,(- (expt 2 32) 7) 3245 42 63 15) (12 1345 13 524562) (t nil t t nil t nil nil) ())
		   ((,(- (expt 2 32) 7) 3245 42 63 15) (32 1345 13 524562) (t t t t nil t nil nil) ())
		   ((,(- (expt 2 32) 1) 3245 42 63 15) (100 1345 13 524562) (t nil t t nil t nil nil) ())
		   ((,(- (expt 2 32) 1) 3245 42 63 15) (100 1345 13 524562) ,(list-duplicate t 1000) ())
		   ((0 0 3456 1345 13 524562) (0 0 3245 42 63 15) (t nil t t nil t nil nil) ()))
		   )
	 (nondets* (create-random-nondets 100 (+ (floor (length assignments) 2))))
	 (nondets** (create-random-nondets-constants 100 (+ (floor (length assignments) 2)) constants))
	 (states (create-state-from-nondets-at node (append nondets nondets* nondets**) assignments)))
    states))


;; pgraph pgraph-ACL2-data N N [node list] node ??? [assignment list] -> [node-name [assignment list] mmap]
;; compute traces which begin at the given node with the given assignments, and that live within the given component
(defun generate-traces-at (pgraph pgraph-ACL2-data fuel component node constants assignments mmap)
  (let* ((start (get-internal-real-time))
	 (res (let* ((nodes (pgraph.nodes pgraph))
		     (states (create-states-at node constants assignments))
		     (_ (list.iter #'(lambda (state)
				       #|(let* ((sizes (mmap.empty)))
				       (list.iter #'(lambda (node) (mmap.add-exn sizes (node.name node) 0)) nodes)
				       (mmap.add-overwrite sizes (node.name node) (length states))
				       (generate-trace-in-component fuel state node pgraph pgraph-ACL2-data mmap sizes component))|#
				       (generate-trace-in-component-modified fuel state node pgraph pgraph-ACL2-data mmap component)
				       )
				   states)))
		'_))
	 (end (get-internal-real-time)))
    (setf *total-trace-time* (+ *total-trace-time* (- end start)))
    res))
